<template>
  <div>
    <h2 class="is-size-4 first-letter-colored">
      {{ $t('steps.title') }}
    </h2>

    <b-table
      class="has-text-left"
      :data="steps"
      :striped="true"
      :loading="loading"
      :hoverable="true">

      <b-table-column field="name"
                      :label="$t('steps.game')"
                      searchable>
        <template
          slot="searchable"
          slot-scope="props">
          <b-input
              v-model="props.filters[props.column.field]"
              placeholder="..."
              icon="search"
              size="is-small" />
        </template>
        <template v-slot="props">
          {{ props.row.name }}
        </template>
      </b-table-column>

      <b-table-column v-for="name in stepNames"
                      :key="name"
                      :field="name">
        <template v-slot:header>
          <step-icon :name="name" />
          {{ $t(`steps.${name}`) }}
        </template>
        <template v-slot="props">
          <span :class="`has-text-${name} has-text-weight-bold`">
            {{ $n(props.row[name]) }}
          </span>
        </template>
      </b-table-column>
    </b-table>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { map } from 'lodash';
import LoadingMixin from '../../mixins/loading.vue';
import { GameName } from '@/types/games';
import StepIcon from '@/components/StepIcon.vue';

export enum StepNames {
  GREEN = 'green',
  ORANGE = 'orange',
  RED = 'red',
  MAX = 'max',
}

interface GameStep {
  name: GameName;
  green: number,
  orange: number,
  red: number,
  max: number,
}

@Component({
  components: { StepIcon }
})
export default class Steps extends LoadingMixin {
  steps: GameStep[] = [];
  stepNames: readonly string[] = Object.values(StepNames);

  async mounted() {
    const { data } = await this.$http.get('scores/steps');

    this.formatSteps(data);
    this.stopLoading();
  }

  formatSteps(stepsData): void {
    this.steps = Object.entries(stepsData).map((s): GameStep => {
      const [green, orange, red, max] = map(s[1], 'value');
      return {
        name: <GameName>s[0],
        green,
        orange,
        red,
        max
      };
    });
  }
}
</script>

<style lang="scss">
th .icon {
  @extend .mx-0;
}
</style>
